/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_NATUASSU                                                 */
/* Tabela : NATUASSU                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 17/06/2003 Gianne Dolores                                                  */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_NATUASSU
BEFORE INSERT OR UPDATE OR DELETE
ON NATUASSU FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUNATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDNATUASSU,0)  <> NVL(:NEW.CDNATUASSU,0)) OR
         (NVL(:OLD.NMNATUASSU,0)  <> NVL(:NEW.NMNATUASSU,0)) THEN
         :NEW.DTULTATUNATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('NATUASSU', '', 'CDNATUASSU='||:OLD.CDNATUASSU||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE NATUASSU MODIFY DTULTATUNATU DEFAULT SYSDATE
/
