function Ped04400_previsao_de_vendas_Controller(templateManager, ScreenService, General, Ped04400_previsao_de_vendas_Service, restEngine, ZhFilterPreferences, ZHPromise, Exp00200_lancamentoExpedicaoPedido_Service, MessageService) {
    
     this.filterOnEnter = function(widget){
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
        }.bind(this)); 
    };
    
    this.filterPrevisao = function(){
        var widget = templateManager.container.getActiveWidget();
        var widgetPrev = templateManager.container.getWidget('widgetPrevisao');
        
        if(widget.currentRow.DTPREVIVENDA){
            widgetPrev.dataSourceFilter[0].name = "P_DATA";
            widgetPrev.dataSourceFilter[0].value = widget.currentRow.DTPREVIVENDA.start;
            widgetPrev.dataSourceFilter[1].name = "P_DATAFIN";
            widgetPrev.dataSourceFilter[1].value = widget.currentRow.DTPREVIVENDA.end;
        }
    };
    
    this.filterFix = function(widget){
        widget.dataSourceFilter.forEach(function(element, index){
            if(element.name === "DTPREVIVENDA"){
                widget.dataSourceFilter.splice(index,1);
            }
        });
        widget.reload();
    };
    
    this.getCDFILIALfilter = function(){
    
        Ped04400_previsao_de_vendas_Service.getFilialLogada().then(function(filialLogada) {
            var widget = templateManager.container.getWidget('widgetPrevisao');
            widget.currentRow.CDFILIAL = filialLogada[0].CDFILIAL;
            widget.getField('CDFILIAL').reload();
            widget.currentRow.NMFILIAL = filialLogada[0].NMFILIAL;
            widget.getField('NMFILIAL').reload();
            
        });
    };
    
    this.novaPrevisao = function(widget){
        
        widget.newRow();
        widget.currentRow.CDFILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL;    
        widget.currentRow.NMFILIAL = widget.appliedFilter.FILTER_ROW.NMFILIAL;
        widget.currentRow.DTPREVIVENDA = moment().format("DD/MM/YYYY");
    };
    
    this.savePrevisao = function(widget){
        var DTPREVIVENDA = widget.currentRow.DTPREVIVENDA.substring(6,10)+'-'+widget.currentRow.DTPREVIVENDA.substring(3,5)+'-'+widget.currentRow.DTPREVIVENDA.substring(0,2);
        if(DTPREVIVENDA > moment().format("YYYY-MM-DD")){
            General.saveCrud(widget);
        } else if(DTPREVIVENDA === moment().format("YYYY-MM-DD")){
/*            ScreenService.showCustomDialog('Deseja salvar uma previsão de venda para a data de hoje, '+widget.currentRow.DTPREVIVENDA+'?', 'question', 'question', [
                {
                    label: ScreenService.i18n("Sim"),
                    code: function(){
                        General.saveCrud(widget);
                    }
                },
                {
                    label: ScreenService.i18n("Não"),
                    code: function(){}
                }]);
*/
            var messageCode = "PREVISAO_VENDA_MSG";
           
            var messageParameters = {
                "DATA" : widget.currentRow.DTPREVIVENDA
            };
           
            var dialogConfig ={
                type: 'question',
                icon: 'question',
                actions: [
                    {
                    label: ScreenService.i18n("Sim"),
                    code: function(){
        	                General.saveCrud(widget);
            	        }  
                    },  
                    {
                        label: ScreenService.i18n("Não"),
                            code: function(){}
                    }
                ]
            };
            MessageService.showCustomDialogByCode(messageCode, messageParameters, dialogConfig);
            
        } else if(DTPREVIVENDA < moment().format("YYYY-MM-DD")){
            //ScreenService.showMessage('Não é possivel salvar uma previsão de venda para uma data anterior a data de hoje, dia '+moment().format("DD/MM/YYYY"));
            
            var data_previsao = moment().format("DD/MM/YYYY");
            var var_erro_previsao = "ERRO_PREVISAO_MSG";
            MessageService.showMessageByCode(var_erro_previsao,{"DATA":data_previsao});
            widget.currentRow.DTPREVIVENDA = "";
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped04400_previsao_de_vendas_Controller', Ped04400_previsao_de_vendas_Controller);
});